package com.cntaiping.intserv.coverage.bmodel;

import com.cntaiping.intserv.enotice.bmodel.EisNoticeIndivid;

import java.io.Serializable;
import java.util.Date;

/**
 * @author ManBu
 * Created at  2019/4/9 9:39
 */
public class CoverMessageIndividBO extends EisNoticeIndivid implements Serializable {
    private static final long serialVersionUID = -492276566929815911L;
    /**
     *  Ϣرʱ
     */
    private Date closeTime;
    /**
     * ״βʱ
     */
    private Date fstOperatorTime;

    /**
     * һβʱ
     */
    private Date lstOperatorTime;

    public Date getCloseTime() {
        return closeTime;
    }

    public void setCloseTime(Date closeTime) {
        this.closeTime = closeTime;
    }

    public Date getFstOperatorTime() {
        return fstOperatorTime;
    }

    public void setFstOperatorTime(Date fstOperatorTime) {
        this.fstOperatorTime = fstOperatorTime;
    }

    public Date getLstOperatorTime() {
        return lstOperatorTime;
    }

    public void setLstOperatorTime(Date lstOperatorTime) {
        this.lstOperatorTime = lstOperatorTime;
    }

    public EisNoticeIndivid toEisNoticeIndivid(){
        EisNoticeIndivid individNotice = new EisNoticeIndivid();
        individNotice.setNoticeId(this.getNoticeId());
        individNotice.setNoticeCate(this.getNoticeCate());
        individNotice.setNoticeSource(this.getNoticeSource());
        individNotice.setNoticeTitle(this.getNoticeTitle());
        individNotice.setNoticeContent(this.getNoticeContent());
        individNotice.setSendUser(this.getSendUser());
        individNotice.setRecvUser(this.getRecvUser());
        individNotice.setRemark(this.getRemark());
        individNotice.setOperateType(this.getOperateType());
        individNotice.setRawSeqId(this.getRawSeqId());
        individNotice.setSendUserCate(this.getSendUserCate());
        individNotice.setRecvUserCate(this.getRecvUserCate());
        individNotice.setSendStatus(this.getSendStatus());
        individNotice.setNoticeTitleDesc(this.getNoticeTitleDesc());
        individNotice.setIsHaveDetails(this.getIsHaveDetails());
        individNotice.setIsNeedInform(this.getIsNeedInform());
        individNotice.setMuid(this.getMuid());
        individNotice.setRemoteNoticeId(this.getRemoteNoticeId());
        individNotice.setNoticeDesc(this.getNoticeDesc());
        return individNotice;
    }
}
