package com.cntaiping.intserv.coverage.product;

import java.util.Date;
import java.util.List;
import java.util.Map;

import com.cntaiping.intserv.basic.auth.user.ISUser;
import com.cntaiping.intserv.coverage.bmodel.*;


public interface ProductInfo {
	/**
     * ѯҳϢ,ͼƬббƷбƷбȨ޿
     * 1.userSource
     * 2.userId
     * 3.deviceType  豸[2-iphone,1-ipad,4-android]
     * 4.deviceId    豸к
     * 5.sellChannel Ӧָͣպգ
     * 6.organId     
     * 7.user        ûϢ
     */
    public Map queryIndexInfo(Integer userSource,String userId, String deviceType, String deviceId, String sellChannel, String organId, String plantId, ISUser user, Date lastRquestDate, int version) throws Exception;
	
    /**
     * ѯķ
     * @param userSource  ûԴ
     * @param userId      ûID
     * @param deviceType  豸
     * @param deviceId    豸к
     * @param sellChannel 
     * @param ISUser      ûϢ
     * @param ActivityId  ID
     */
    public Map queryActivity(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, ISUser user,String ActivityId) throws Exception;

    /**
     * ʾ¼
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param share      CoverShareBO
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;shareUrl-;shareCode-)
     */
    public Map saveCoverShare(Integer userSource, String userId, Integer deviceType, String deviceId, String sellChannel, String plantId, CoverShareBO share) throws Exception;

    /**
     * ʾ켣¼
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param sellChannel 
     * @param showList   List<CoverShowBO>
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;lastShowNo-)
     */
    public Map saveCoverShowList(Integer userSource, String userId, Integer deviceType, String deviceId, String sellChannel, List<CoverShowBO> showList) throws Exception;


    /**
     * ȡϢ
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @return AgentInfoBO
     */
    public AgentInfoBO getAgentInfo(Integer userSource, String userId) throws Exception;

    /**
     * ѯ߲ƷԴ
     * <p>
     * 1.userSource  ûԴûԴ(1-;2-;3-ͻ)
     * 2.userId      ûid
     * 3.deviceType  豸[2-iphone,1-ipad,4-android]
     * 4.deviceId    豸id
     * 5.sellChannel [1-;3-;5-Ԫ]
     * 6.productId   ƷId
     *
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;coverOffLineList<CoverOffLineBo>);[productId-ƷId;fileSize-ԴļܴС]
     */
    public Map queryProductZipSize(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, String productId) throws Exception;

    /**
     * ƷԴ,ֶ֧ϵ
     * 1.userSource  ûԴ[1-,2-,3-ͻ]
     * 2.userId      ûid
     * 3.deviceType  豸[2-iphone,1-ipad,4-android]
     * 4.deviceId    豸id
     * 5.sellChannel [1-;3-;5-Ԫ]
     * 6.productId   ƷId
     * 7.startIndex  ʼ
     * 8.downloadSize شС
     * return HashMap(resultCode-־;errorCode-;errorDesc-;);
     */
    public Map downloadProductZip(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, CoverOffLineBO coverOffLineBO) throws Exception;

    
    /**
     * ȡƷ,Ϣ
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;OPERATOR_DATA-List<CoverProductDataBO>)
     */
    public Map queryProductStatisticsDataList(String userId, String deviceType, String deviceId, String sellChannel) throws Exception;

    /**
     * ȡûƻϢ
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;OPERATOR_DATA-List<PlaneBookDateBO>)
     */
    public Map queryUserShareList(String userId, String deviceType, String deviceId, String sellChannel, PageInfoBO pageInfoBO) throws Exception;

    /**
     * Ϣ¼
     *
     * @param userSource ûԴ(1-;2-;3-ͻ;4-׼)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param activity   CoverActivityBO
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
     */
    public Map saveOperatorLog(Integer userSource, String userId, Integer deviceType, String deviceId, CoverOperatorBO operator) throws Exception;

    /**
     * ͻϢʾ
     *
     * @param userSource      ûԴ(1-;2-;3-ͻ)
     * @param userId          ûID
     * @param deviceType      豸
     * @param deviceId        豸к
     * @param coverBusiCardBO CoverActivityBO(ͻϢBO)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
     */
    public Map saveCoverBusiCard(Integer userSource, String userId, String deviceType, String deviceId, CoverBusiCardBO coverBusiCardBO) throws Exception;

    /**
     * ѯͻϢʾ
     *
     * @param userSource      ûԴ(1-;2-;3-ͻ)
     * @param userId          ûID
     * @param deviceType      豸
     * @param deviceId        豸к
     * @param coverBusiCardBO CoverActivityBO(ͻϢBO)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;CoverBusiCardBO)
     */
    public Map queryCoverBusiCard(Integer userSource, String userId, String deviceType, String deviceId, CoverBusiCardBO coverBusiCardBO) throws Exception;

    /**
     * ͱ涼øýӿ
     * @return
     */
    public Map saveQRCode(String plantId, String sellChannel, String organId, Integer userSource, String userId, String deviceType, String deviceId,byte[] qrcodeData);
    /**
     * רʼ
     * @return
     */
    public Map sendQRCodeMail(String plantId, String sellChannel, String organId, Integer userSource, String userId, String deviceType, String deviceId, byte[] qrcodeData, MailSendBO mailSendBO);

    /**
     * PDF
     *
     * @param userSource   ûԴ(1-;2-;3-ͻ)
     * @param userId       ûID
     * @param deviceType   豸
     * @param deviceId     豸к
     * @param CoverPrintBO CoverPrintBO(ӡBO)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;CoverBusiCardBO)
     */
    public Map savePrintPdf(Integer userSource, String userId, String deviceType, String deviceId, CoverPrintBO printBO) throws Exception;

    /**
     * ʼ
     *
     * @param userSource   ûԴ(1-;2-;3-ͻ)
     * @param userId       ûID
     * @param deviceType   豸
     * @param deviceId     豸к
     * @param CoverPrintBO CoverPrintBO(ӡBO)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;CoverBusiCardBO)
     */
    public Map sendPrintPdfMail(Integer userSource, String userId, String deviceType, String deviceId, CoverPrintMailBO mailBO) throws Exception;

    /**
     * ûϢ
     *
     * @param userSource      ûԴ(1-;2-;3-ͻ)
     * @param userId          ûID
     * @param deviceType      豸
     * @param deviceId        豸к
     * @param sellChannel (1-;3-;5-Ԫ)
     * @param CoverFeedBackBO CoverFeedBackBO(ͻϢBO)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
     */
    public Map saveCoverFeedBack(Integer userSource, String userId, String deviceType, String deviceId,String sellChannel,CoverFeedBackBO coverFeedBackBO) throws Exception;

    /**
     * ѯϢ
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param sellChannel (1-;3-;5-Ԫ)
     * @param organId     ID
     * @return List(resultCode-־;errorCode-;errorDesc-;)
     */
    public List queryMessageRealTimeNew(Integer userSource,String userId, String deviceType, String deviceId, String sellChannel,String organId,ISUser user,String userCate) throws Exception;

    /**
     * ѯղƷб
     *
     * @param userId      ûID
     * @param deviceType  豸
     * @param deviceId    豸к
     * @param sellChannel (1-;3-;5-Ԫ)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;OPERATOR_DATA-List<WealthProductBO>)
     */
    public Map queryWealthProductList(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, CoverProductHotSellBO coverProductHotSellBO) throws Exception;

    
    /**
     * ѯб
     *
     * @param userId      ûID
     * @param deviceType  豸
     * @param deviceId    豸к
     * @param sellChannel (1-;3-;5-Ԫ)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;OPERATOR_DATA-List<EndowmentProductBO>)
     */
    public Map queryEndoProductList(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, CoverProductHotSellBO coverProductHotSellBO) throws Exception;

    /**
     * ѯ΢Ʒб
     *
     * @param userId      ûID
     * @param deviceType  豸
     * @param deviceId    豸к
     * @param sellChannel (1-;3-;5-Ԫ)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;OPERATOR_DATA-List<WebchatProductBO>)
     */
    public Map queryWebChartProductList(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, CoverProductHotSellBO coverProductHotSellBO) throws Exception;

    /**
     * ѯѯϢ
     *
     * @param userId      ûID
     * @param deviceType  豸
     * @param deviceId    豸к
     * @param sellChannel [1-;3-;5-Ԫ]
     * @return HashMap(RESPONSE_CODE-־;RESPONSE_BO-InformationBO)
     */
    public Map queryInfomation(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel) throws Exception;

    /**
     * ѯƷ
     *
     * @param userSource            ûԴ(1-;2-;3-ͻ)
     * @param userId                ûID
     * @param deviceType            豸
     * @param deviceId              豸к
     * @param coverProductHotSellBO Ʒ
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
     */
    public Map queryHotSellProduct(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, CoverProductHotSellBO coverProductHotSellBO) throws Exception;

    /**
     * ѯʹð
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param sellChannel (1-;3-;5-Ԫ)
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
     */
    public Map queryUseingHelpList(Integer userSource, String userId, String deviceType, String deviceId,String sellChannel,CoverUseingHelpBO coverUseingHelpBo) throws Exception;

    /**
     * ѯź״̬
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
     */
    public Map queryProductGreatStartStatus(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel) throws Exception;

    /**
     * ѯźϢ
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
     */
    public Map queryProductGreatStartInfo(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel,Map param,String product_id) throws Exception;
    /**
     *ͳƿź
     * 
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param sellChannel 
     * @param item       Ųͬ
     * @return
     * @throws Exception
     */
    public Map saveGreatStartShowNum(Integer userSource, String userId, String deviceType, String deviceId, String product_id,String sellChannel,Integer item) throws Exception;
    /**
     * ѯҫרƷ
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param sellChannel  1-գ2-
     * @return
     */
      public Map queryDistrictActivityStatus(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel) throws Exception;

    /**
     *
     * @param userSource ûԴ(1-;2-;3-ͻ)
     * @param userId     ûID
     * @param deviceType 豸
     * @param deviceId   豸к
     * @param sellChannel 1-գ2-
     * @param product_id  Ʒid
     * @return
     * @throws Exception
     */
      public Map queryDistrictActivityInfo(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel,String product_id,String token) throws Exception;

        /**
          * ѯû֤Ϣ
          *
          * @param userSource ûԴ(1-;2-;3-ͻ)
          * @param userId     ûID
          * @param deviceType 豸
          * @param deviceId   豸к
          * @return HashMap(resultCode-־;errorCode-;errorDesc-;)
          */
       public Map queryEntryCheckKey(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel)throws Exception;
       
       /**
        * ֶ߲Ʒ
        * 
        * @param userSource ûԴ(1-;2-;3-ͻ)
        * @param userId ûID
        * @param deviceType 豸
        * @param deviceId 豸к
        * @param sellChannel 
        * @param coverOffLineBO
        * @return ѹstartIndex readLengthƬ
        * @throws Exception
        */
       public Map downloadProductZipTemp(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, CoverOffLineBO coverOffLineBO) throws Exception;
       
       /**
        * 
        * ѯƷб
        * 
        * ipad߰ר
        * 
        * @param userId ûID
        * @param deviceType 豸
        * @param deviceId 豸к
        * @param sellChannel
        * @return
        * @throws Exception
        */
       public Map queryProductList(String userId, String deviceType, String deviceId, String sellChannel) throws Exception;
       
       /**
        * 
        * ѯ ֲͼ
        * 
        * ipad߰ר
        * 
        * @param userId ûID
        * @param deviceType 豸
        * @param deviceId 豸к
        * @param sellChannel
        * @return
        * @throws Exception
        */
       public Map queryRollPicList(String userId, String deviceType, String deviceId, String sellChannel) throws Exception;
       
       /**
        * ûļƻ飬ƻٴδʱȡأshareCodestatusΪ2
        * 
        * @param userSource ûԴ(1-;2-;3-ͻ)
        * @param userId ûID
        * @param deviceType 豸
        * @param deviceId 豸к
        * @param sellChannel 
        * @param shareCode 
        * @return
        * @throws Exception
        */
       public Map hideUserShareView(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, String shareCode) throws Exception;

    /**
     * ѯûƻϢЧ
     * @param userSource
     * @param userId
     * @param deviceType
     * @param deviceId
     * @param sellChannel
     * @param shareCode
     * @return
     * @throws Exception
     */
    public Map queryPolicyEnableByCode(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, String shareCode) throws Exception;


     /**
      * û
      * @param userSource
      * @param userId
      * @param deviceType
      * @param deviceId
      * @param sellChannel
      * @param settingKey
      * @param settingValue
      * @return (resultCode-־;errorCode-;errorDesc-;)
      * @throws Exception
     */
    public Map updateUserSetting(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel,String settingKey,String settingValue) throws Exception;

    /**
     * ѯ汾ͼ
     * @param userSource
     * @param userId
     * @param deviceType
     * @param deviceId
     * @param sellChannel
     * @param organId
     * @param version
     * @return
     * @throws Exception
     */
    public Map queryVersionTips(Integer userSource, String userId, String deviceType, String deviceId, String sellChannel, String organId, int version) throws Exception;
}
